;												
; PLL-TESTGENERATOR 							
; Bernhard.Erfurt@gmx.de						
; 17.02.2014									
;												


; Anschlussbelegung PINS						
;												
; PB0 ==> 
; PB1 ==> SIGNAL-OUT							
; PB2 ==> 
; PB3 ==> 
; PB4 ==> 
; PB5 ==> 
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> TRIGGER-OUT							
; PC1 ==> 
; PC2 ==> 
; PC3 ==> 
; PC4 ==> 
; PC5 ==> 
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								

; ATmega8 										
.include "m8def.inc"

.equ TAKT=16000000

; f=TAKT/2*N*(1+OCR)
; OCR=TAKT/2f-1
.equ FREQUENZ_A=19000
.equ FREQUENZ_B=19000-100

.equ WERT_A=(TAKT/(2*FREQUENZ_A))-1
.equ WERT_B=(TAKT/(2*FREQUENZ_B))-1
; AUSGANG										
.equ AUSGANG_PIN_NR					= 1
.equ AUSGANG_PIN					= PINB
.equ AUSGANG_DDR					= DDRB
.equ AUSGANG_PORT					= PORTB
; TRIGGER										
.equ TRIGGER_PIN_NR					= 0
.equ TRIGGER_DDR					= DDRC
.equ TRIGGER_PORT					= PORTC
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD

.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0				

rjmp RESET      	 ; Reset Handler                           			  
rjmp INTERRUPT_ERROR ;rjmp EXT_INT0   ; IRQ0 Handler                      
rjmp INTERRUPT_ERROR ;rjmp EXT_INT1   ; IRQ1 Handler                      
rjmp INTERRUPT_ERROR ;rjmp TIM2_COMP  ; Timer2 Compare Handler            
rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF   ; Timer2 Overflow Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT  ; Timer1 Capture Handler            
rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_OVF   ; Timer1 Overflow Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF   ; Timer0 Overflow Handler           
rjmp INTERRUPT_ERROR ;rjmp SPI_STC    ; SPI Transfer Complete Handler     
rjmp INTERRUPT_ERROR ;rjmp USART_RXC  ; USART RX Complete Handler         
rjmp INTERRUPT_ERROR ;rjmp USART_UDRE ; UDR Empty Handler                 
rjmp INTERRUPT_ERROR ;rjmp USART_TXC  ; USART TX Complete Handler         
rjmp INTERRUPT_ERROR ;rjmp ADC        ; ADC Conversion Complete Handler   
rjmp INTERRUPT_ERROR ;rjmp EE_RDY     ; EEPROM Ready Handler              
rjmp INTERRUPT_ERROR ;rjmp ANA_COMP   ; Analog Comparator Handler         
rjmp INTERRUPT_ERROR ;rjmp TWSI       ; Two-wire Serial Interface Handler 
rjmp INTERRUPT_ERROR ;rjmp SPM_RDY    ; Store Program Memory Ready Handler


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR



RESET:                        
;STACK initialisieren
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; 
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp	
; PORT LED											
	; auf AUSGANG									
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN	
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB	
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT	
	; LEDs an										
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
; PORT AUSGANG										
	sbi (AUSGANG_DDR),(AUSGANG_PIN_NR)			; (OC1A)	
; PORT-TRIGGER										
	sbi (TRIGGER_DDR),(TRIGGER_PIN_NR)			; 
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED-TEST											
	rcall LED_TEST
; CTC												
	rcall CTC_INITIALISIEREN
; Frequenz einstellen								
   	rcall FREQUENZ_A_EINSTELLEN    

	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an		    
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR

	rcall GENERATOR_A	; Impulse auslassen		
;	rcall GENERATOR_B	; 180 GRD Phasenwechsel	
;	rcall GENERATOR_C	; FREQUENZWECHSEL		

	rcall wait_1s
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EINIGE Impulse auslassen (Port wird auf Eingang geschaltet)					
GENERATOR_A:
	rcall WAIT_AUSGANG_LOW_HIGH				; Warten, bis Ausgang auf HIGH springt
	cbi (AUSGANG_DDR),(AUSGANG_PIN_NR)		; auf EINGANG(OC1A)	
	cbi (TRIGGER_PORT),(TRIGGER_PIN_NR)		; TRIGGER	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB an	
;-------------------------------------------------------------------------------
	ldi temp1,255
GENERATOR_A_s:
	rcall wait_1us
	dec temp1
	brne GENERATOR_A_s
;-------------------------------------------------------------------------------
	sbi (AUSGANG_DDR),(AUSGANG_PIN_NR)		; auf AUSGANG (OC1A)
	sbi (TRIGGER_PORT),(TRIGGER_PIN_NR)		; TRIGGER	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ca. 180 Grad Phasenwechse														
GENERATOR_B:
	rcall WAIT_AUSGANG_LOW_HIGH				; Warten, bis Ausgang auf HIGH springt
	cbi (TRIGGER_PORT),(TRIGGER_PIN_NR)		; TRIGGER	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB an	
;-------------------------------------------------------------------------------
    ldi temp1,LOW (65535-350) 
    ldi temp2,high(65535-350) 

	out TCNT1H,temp2
	out TCNT1L,temp1
;-------------------------------------------------------------------------------
	sbi (TRIGGER_PORT),(TRIGGER_PIN_NR)		; TRIGGER	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; FREQUENZWECHSEL																
GENERATOR_C:
	rcall WAIT_AUSGANG_LOW_HIGH				; Warten, bis Ausgang auf HIGH springt
	cbi (TRIGGER_PORT),(TRIGGER_PIN_NR)		; TRIGGER	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB an	
;-------------------------------------------------------------------------------
   	rcall FREQUENZ_B_EINSTELLEN  
	rcall wait_1s
;-------------------------------------------------------------------------------
	sbi (TRIGGER_PORT),(TRIGGER_PIN_NR)		; TRIGGER	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus	
   	rcall FREQUENZ_A_EINSTELLEN  
	rcall wait_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Warten, bis Ausgang auf HIGH springt
WAIT_AUSGANG_LOW_HIGH:
	sbic (AUSGANG_PIN),(AUSGANG_PIN_NR)	; springe, wenn BIT(PIN) LOW	
	rjmp WAIT_AUSGANG_LOW_HIGH
WAIT_AUSGANG_LOW_HIGH_w:
	sbis (AUSGANG_PIN),(AUSGANG_PIN_NR)	; springe, wenn BIT(PIN) high	
	rjmp WAIT_AUSGANG_LOW_HIGH_w
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
CTC_INITIALISIEREN:
; Vorteiler													
; cs12 cs11 cs10											
;	0 	0 	0 	No clock source. (Timer/Counter stopped)	
; *	0 	0 	1 	clkI/O/1 (No prescaling)					
;	0 	1 	0 	clkI/O/8 (From prescaler)					
;	0 	1 	1 	clkI/O/64 (From prescaler)					
;	1 	0 	0 	clkI/O/256 (From prescaler)					
;	1 	0 	1 	clkI/O/1024 (From prescaler) 				
   ldi     r16,(1<<wgm12|0<<cs12|0<<cs11|1<<cs10)  
   out     tccr1B,r16  
;  Compare Output Mode 
   ldi temp, (1<<com1A0)
   out TCCR1A,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FREQUENZ_A_EINSTELLEN:
    ldi     temp,high(WERT_A)                 
    out     ocr1AH, temp             
 
  	ldi     temp,low(WERT_A)
   	out     ocr1AL,temp   
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FREQUENZ_B_EINSTELLEN:
    ldi     temp,high(WERT_B)                 
    out     ocr1AH, temp             
 
  	ldi     temp,low(WERT_B)
   	out     ocr1AL,temp   
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

;.include "ST_WAIT_01MHZ.asm"		;  1 MHz						
.include "GENERATOR_SONSTIGES.asm"
.include "GENERATOR_WAIT_16MHZ.asm"		; 16 MHz	
